      integer function pdgtran(ID,mconv)
C...convert (mconv=1) from PDG96 numbering scheme to STD numbering scheme
C...     or (mconv=2) from STD numbering scheme to PDG96 numbering scheme
C
C           ID = particle identification number

#include "stdlun.inc"
C... ITABJ(I) converts miscellaneous PDG92 particle ID's to a standard scheme
      integer itabj(99,2), noant(6,2)

      data itabj/1,2,3,4,5,6,7,8,0,0,
     1           11,12,13,14,15,16,0,0,0,0,
     2           21,22,23,24,25,0,0,0,0,0,
     3           0,0,0,0,35,36,37,0,0,0,
     4           0,0,0,0,0,0,0,0,0,0,
     5           0,0,0,0,0,0,0,0,0,0,
     6           0,0,0,0,0,0,0,0,0,0,
     7           0,0,0,0,0,0,0,0,0,0,
     8           81,82,83,84,85,86,87,88,89,90,
     9           91,92,93,94,95,96,97,98,99,
     *           1,2,3,4,5,6,7,8,0,0,
     1           11,12,13,14,15,16,0,0,0,0,
     2           21,22,23,24,25,0,0,0,0,0,
     3           0,0,0,0,35,36,37,0,0,0,
     4           0,0,0,0,0,0,0,0,0,0,
     5           0,0,0,0,0,0,0,0,0,0,
     6           0,0,0,0,0,0,0,0,0,0,
     7           0,0,0,0,0,0,0,0,0,0,
     8           81,82,83,84,85,86,87,88,89,90,
     9           91,92,93,94,95,96,97,98,99/
      data noant/-21,-22,-23,-25,-35,-36,-21,-22,-23,-25,-35,-36/
      save itabj,noant

      pdgtran=id
      ida=iabs(id)
      j1=mod(ida,10)
      i1=mod(ida/10,10)
      i2=mod(ida/100,10)
      i3=mod(ida/1000,10)
      i4=mod(ida/10000,10)
      kqn=mod(ida/1000000000,10)

      if(ida.eq.0)then
C..        write(lnhout,*) ' PDGTRAN 1: particle ID is zero'
      elseif(mconv.lt.1 .or. mconv.gt.2)then
        pdgtran=0
        write(lnhout,*) ' PDGTRAN 2: unallowed conversion option'
C... ions not allowed
      elseif(kqn.eq.1) then
        pdgtran=0
        write(lnhout,*) ' PDGTRAN 3: unallowed ion'
      elseif(ida.lt.100)then
C...Higgs, etc.
        pdgtran=isign(itabj(ida,mconv),id)
C...check for illegal antiparticles
        if(id.lt.0)then
          if(pdgtran.ge.-99 .and. pdgtran.le.-81) pdgtran = 0
          do 101 j=1,6
            if(pdgtran.eq.noant(j,mconv)) pdgtran = 0
 101      continue
        endif
      elseif(i1.ne.0 .and. i3.ne.0 .and. j1.eq.2)then
C...spin 1/2 baryons
C...no excited baryon states
        if(mconv.eq.1)then
          if(i4.ne.0) pdgtran = 0
          if(i3.eq.1) pdgtran = 0
          if(i3.eq.2 .and. i2.eq.1 .and. i1.eq.2) pdgtran = 0
          if(i3.eq.2 .and. i2.eq.2 .and. i1.eq.2) pdgtran = 0
        endif
        if(i3.eq.4 .and. i2.eq.3 .and. i1.le.2)then
          pdgtran = 1000*i3+i1*100+i2*10+j1
        endif
      elseif(i1.ne.0 .and. i3.ne.0 .and. j1.eq.4)then
C...spin 3/2 baryons
C...no excited baryon states
        if(mconv.eq.1)then
          if(i4.ne.0) pdgtran = 0
          if(i3.ge.3 .and. i2.eq.1 .and. i1.eq.2) pdgtran = 0
          if(i3.eq.1 .and. i2.eq.2 .and. i1.eq.1) pdgtran = 0
          if(i3.eq.2 .and. i2.eq.1 .and. i1.eq.2) pdgtran = 0
        endif
      elseif(i1.ne.0 .and. i2.ne.0 .and. i3.eq.0)then
C...mesons 
        if(mconv.eq.1)then
          if(ida.eq.10111) pdgtran=isign(9000111,id)
          if(ida.eq.20211) pdgtran=isign(9000211,id)
          if(ida.eq.20111) pdgtran=isign(100111,id)
          if(ida.eq.20211) pdgtran=isign(100211,id)
          if(ida.eq.40113) pdgtran=isign(100113,id)
          if(ida.eq.40213) pdgtran=isign(100213,id)
          if(ida.eq.10221) pdgtran=isign(9010221,id)
          if(ida.eq.20221) pdgtran=isign(100221,id)
          if(ida.eq.30221) pdgtran=isign(10221,id)
          if(ida.eq.40221) pdgtran=isign(100331,id)
          if(ida.eq.50221) pdgtran=isign(9020221,id)
          if(ida.eq.60221) pdgtran=isign(9030221,id)
          if(ida.eq.30223) pdgtran=isign(20333,id)
          if(ida.eq.40223) pdgtran=isign(9000223,id)
          if(ida.eq.50223) pdgtran=isign(100223,id)
          if(ida.eq.60223) pdgtran=isign(30223,id)
          if(ida.eq.10333) pdgtran=isign(100333,id)
          if(ida.eq.20225) pdgtran=isign(100335,id)
          if(ida.eq.30225) pdgtran=isign(9050225,id)
          if(ida.eq.40225) pdgtran=isign(9060225,id)
          if(ida.eq.30313) pdgtran=isign(100313,id)
          if(ida.eq.30323) pdgtran=isign(100323,id)
          if(ida.eq.40313) pdgtran=isign(30313,id)
          if(ida.eq.40323) pdgtran=isign(30323,id)
          if(ida.eq.10443) pdgtran=isign(20443,id)
          if(ida.eq.20443) pdgtran=isign(100443,id)
          if(ida.eq.40443) pdgtran=isign(9000443,id)
          if(ida.eq.50443) pdgtran=isign(9010443,id)
          if(ida.eq.60443) pdgtran=isign(9020443,id)
          if(ida.eq.551)   pdgtran=isign(10551,id)
          if(ida.eq.10551) pdgtran=isign(110551,id)
          if(ida.eq.10553) pdgtran=isign(20553,id)
          if(ida.eq.20553) pdgtran=isign(100553,id)
          if(ida.eq.30553) pdgtran=isign(200553,id)
          if(ida.eq.40553) pdgtran=isign(300553,id)
          if(ida.eq.50553) pdgtran=isign(9000553,id)
          if(ida.eq.60553) pdgtran=isign(9010553,id)
          if(ida.eq.70553) pdgtran=isign(120553,id)
          if(ida.eq.10555) pdgtran=isign(100555,id)
        elseif(mconv.eq.2) then
          if(ida.eq.9000111) pdgtran=isign(10111,id)
          if(ida.eq.9000211) pdgtran=isign(10211,id)
          if(ida.eq.10111) pdgtran=0
          if(ida.eq.20211) pdgtran=0
          if(ida.eq.100111) pdgtran=isign(20111,id)
          if(ida.eq.100211) pdgtran=isign(20211,id)
          if(ida.eq.100113) pdgtran=isign(40113,id)
          if(ida.eq.100213) pdgtran=isign(40213,id)
          if(ida.eq.100221) pdgtran=isign(20221,id)
          if(ida.eq.10221) pdgtran=isign(30221,id)
          if(ida.eq.100331) pdgtran=isign(40221,id)
          if(ida.eq.9010221) pdgtran=isign(10221,id)
          if(ida.eq.9020221) pdgtran=isign(50221,id)
          if(ida.eq.9000221) pdgtran=isign(60221,id)
          if(ida.eq.9030221) pdgtran=isign(60221,id)
          if(ida.eq.9000223) pdgtran=isign(40223,id)
          if(ida.eq.20333) pdgtran=isign(30223,id)
          if(ida.eq.100223) pdgtran=isign(50223,id)
          if(ida.eq.30223) pdgtran=isign(60223,id)
          if(ida.eq.100333) pdgtran=isign(10333,id)
          if(ida.eq.10335) pdgtran=0
          if(ida.eq.100335) pdgtran=isign(20225,id)
          if(ida.eq.9050225) pdgtran=isign(30225,id)
          if(ida.eq.9060225) pdgtran=isign(40225,id)
          if(ida.eq.100313) pdgtran=isign(30313,id)
          if(ida.eq.100323) pdgtran=isign(30323,id)
          if(ida.eq.30313) pdgtran=isign(40313,id)
          if(ida.eq.30323) pdgtran=isign(40323,id)
          if(ida.eq.20443) pdgtran=isign(10443,id)
          if(ida.eq.100443) pdgtran=isign(20443,id)
          if(ida.eq.9000443) pdgtran=isign(40443,id)
          if(ida.eq.9010443) pdgtran=isign(50443,id)
          if(ida.eq.9020443) pdgtran=isign(60443,id)
          if(ida.eq.10551) pdgtran=isign(551,id)
          if(ida.eq.110551) pdgtran=isign(10551,id)
          if(ida.eq.20553) pdgtran=isign(10553,id)
          if(ida.eq.100553) pdgtran=isign(20553,id)
          if(ida.eq.200553) pdgtran=isign(30553,id)
          if(ida.eq.300553) pdgtran=isign(40553,id)
          if(ida.eq.9000553) pdgtran=isign(50553,id)
          if(ida.eq.9010553) pdgtran=isign(60553,id)
          if(ida.eq.120553) pdgtran=isign(70553,id)
          if(ida.eq.100555) pdgtran=isign(10555,id)
        endif
C...check for illegal antiparticles
        if(i1.eq.i2 .and. id.lt.0) pdgtran=0
      elseif(i2.ne.0 .and. i3.ne.0 .and. i1.eq.0)then
C...diquarks
      else
C...undefined
        pdgtran=0
      endif
C...check for illegal anti KS, KL
      if(id.eq.-130 .or. id.eq.-310) pdgtran=0
#if HEPDBG
C...there are too many warnings - use only for debugging purposes
      if(pdgtran.eq.0 .and. ida.ne.0)then
        if(mconv.eq.1) write(lnhout,111) id
        if(mconv.eq.2) write(lnhout,112) id
      endif
#endif
      return
 111  format('  PDGTRAN 3: PDG92 particle ',I8,' translates to zero')
 112  format('  PDGTRAN 3: STD particle ',I8,' translates to zero')
      end
